﻿
/*
 * numInput ver 2021/05/05
 * https://www.spreadi-vision.com/
 * Copyright (C) 2021 システム開発の【Spread i-Vision】
 * 
 * １．使用する際は、コメントいただけるとありがたいですが、特になくても大丈夫です。
 * ２．ソースの改修は自由に行っていただいて大丈夫ですが、トップのコピーライトは消さないで下さい。
 * ３．使用料はかかりません。
 * ４．不具合などによる損害は、一切の責任を負いかねます。
 *
 */

const att_val = 'nmb';
const att_val_before = 'nmb_Before';
const att_numInput = 'numInput';
const att_evnt_keyup = 'evnt_keyup';
var mflag = false;
class numInput {
    constructor(inp) {
        var preValue = 0;
        inp.style.textAlign = 'right';
        inp.setAttribute(att_val, '');
        inp.onfocus = function () {
            inp.value = replaceAll(inp.value, ',', '');
            if (inp.value != null && inp.value != '' && isNaN(inp.value) == false) {
                preValue = inp.value;
                inp.setAttribute(att_val_before, preValue);
            }
            else {
                preValue = '';
                inp.setAttribute(att_val_before, 0);
            }
            this.select();
        }
        inp.onblur = function () {
            mflag = false;
            if (inp.value != null && inp.value != '' && isNaN(inp.value) == false) {
                inp.setAttribute(att_val, Number(inp.value));
                inp.value = Number(inp.value).toLocaleString();
            }
            else {
                if (inp.value == '') { inp.value = ''; }
                else {
                    inp.setAttribute(att_val, preValue);
                    inp.value = preValue;
                }
            }
        }
        inp.onclick = function () {
            if (mflag == false) {
                inp.select();
                mflag = true;
            }
        }
        inp.onchange = function () { cng(inp); }
        inp.onkeyup = function () { cng(inp); }
        function cng(inp) {
            let att = inp.getAttribute(att_evnt_keyup);
            if (att == null || att != 'true') { return; }

            inp.value = inp.value.replace(/[^0-9^０-９.-]+/i, '');
            inp.value = inp.value.replace(/[０-９]/g, function (s) {
                return String.fromCharCode(s.charCodeAt(0) - 0xFEE0);
            });
            let val = inp.value
            if (val == null || val == '') { inp.setAttribute(att_val, ''); }
            else if (isNaN(replaceAll(val, ',', '')) == false) {
                inp.setAttribute(att_val, replaceAll(val, ',', ''));
            }
        }
    }
}
function replaceAll(str, tgt, rpl) {
    let result = '';
    let offset = 0;
    let target_length = tgt.length;
    if (target_length === 0) {
        for (let i = 0, c = str.length; i < c; i++) {
            result += str[i];
            result += rpl;
        }
        if (result.length) { return result.substr(0, result.length - rpl.length); }
        else { return result; }
    }
    do {
        let i = str.indexOf(tgt, offset);
        if (i === -1) {
            result += str.substring(offset);
            return result;
        }
        result += str.substring(offset, i);
        result += rpl;
        offset = i + target_length;
    } while (true);
}
